module Swagger
  module Api
    module Concerns
      module Columns
        extend ActiveSupport::Concern

        included do
          def columns
            if controller.columns.try(:only).present?
              model.columns.select! do |column|
                controller.columns.only.include?(column.name)
              end
            end

            if controller.columns.try(:except).present?
              model.columns.reject! do |column|
                controller.columns.except.include?(column.name)
              end
            end
            model.columns
          end
        end
      end
    end
  end
end