module Swagger
  module Api
    module Operations
      class Create < Base

        def create
          create = super
          create[:requestBody] = request_body
          create.delete(:parameters)
          create
        end

        def request_body
          {
            "$ref" => "#/components/requestBodies/#{model_name}"
          }
        end

        def error_responses
          super.reject do |error_response|
            error_response.keys.first == '404'
          end
        end
      end
    end
  end
end