module Swagger
  module Api
    module Operations
      class Index < Base
        def parameters
          columns.map do |column|
            {
              name: column.name,
              in: 'query',
              required: false,
              description: "#{column.name} of #{model.name}",
              schema: Swagger::Api::ColumnSchema.new(column: column).create,
            }
          end
        end

        def readable_action
          'list'
        end

        def error_responses
          super.reject do |error_response|
            %w(404).include?(error_response.keys.first)
          end
        end
      end
    end
  end
end