module Swagger
  module Api
    class RequestBodies
      include ActiveAttr::Model
      attr_accessor :controllers

      def create
        request_bodies = {}
        controllers.each do |controller|
          request_bodies[controller.model] = request_body(controller)
        end
        request_bodies
      end

      def request_body(controller)
        {
          content: {
            'application/json' => {
              schema: {
                '$ref' => "#/components/schemas/#{controller.model}"
              }
            }
          },
          description: "audience attribute",
          required: true
        }
      end
    end
  end
end
